org.apache.commons.math.random

## Class MersenneTwister

- java.lang.Object
- - org.apache.commons.math.random.BitsStreamGenerator
  - - org.apache.commons.math.random.MersenneTwister

All Implemented Interfaces:
  java.io.Serializable, RandomGenerator

    public class MersenneTwister
    extends BitsStreamGenerator
    implements java.io.Serializable

This class implements a powerful pseudo-random number generator developed by Makoto Matsumoto and Takuji Nishimura during 1996-1997.

This generator features an extremely long period (219937-1) and 623-dimensional equidistribution up to 32 bits accuracy. The home page for this generator is located at http://www.math.sci.hiroshima-u.ac.jp/~m-mat/MT/emt.html.

This generator is described in a paper by Makoto Matsumoto and Takuji Nishimura in 1998: Mersenne Twister: A 623-Dimensionally Equidistributed Uniform Pseudo-Random Number Generator, ACM Transactions on Modeling and Computer Simulation, Vol. 8, No. 1, January 1998, pp 3--30

This class is mainly a Java port of the 2002-01-26 version of the generator written in C by Makoto Matsumoto and Takuji Nishimura. Here is their original copyright:

Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura, All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
3. The names of its contributors may not be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Since:
  2.0
Version:
  $Revision: 990655 $ $Date: 2010-08-29 23:49:40 +0200 (dim. 29 août 2010) $
See Also:
  Serialized Form

### Field Summary

Fields
`private static int` `M` Period second parameter.
`private static int[]` `MAG01` X * MATRIX_A for X = {0, 1}.
`private int[]` `mt` Bytes pool.
`private int` `mti` Current index in the bytes pool.
`private static int` `N` Size of the bytes pool.
`private static long` `serialVersionUID` Serializable version identifier.

### Constructor Summary

Constructors
Constructor and Description
`MersenneTwister()` Creates a new random number generator.
`MersenneTwister(int seed)` Creates a new random number generator using a single int seed.
`MersenneTwister(int[] seed)` Creates a new random number generator using an int array seed.
`MersenneTwister(long seed)` Creates a new random number generator using a single long seed.

### Method Summary

Methods
`protected int` `next(int bits)` Generate next pseudorandom number.
`void` `setSeed(int seed)` Reinitialize the generator as if just built with the given int seed.
`void` `setSeed(int[] seed)` Reinitialize the generator as if just built with the given int array seed.
`void` `setSeed(long seed)` Reinitialize the generator as if just built with the given long seed.

### Methods inherited from class org.apache.commons.math.random.BitsStreamGenerator

`nextBoolean, nextBytes, nextDouble, nextFloat, nextGaussian, nextInt, nextInt, nextLong`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### N

    private static final int N

Size of the bytes pool.

See Also:
  Constant Field Values

#### M

    private static final int M

Period second parameter.

See Also:
  Constant Field Values

#### MAG01

    private static final int[] MAG01

X * MATRIX_A for X = {0, 1}.

#### mt

    private int[] mt

Bytes pool.

#### mti

    private int mti

Current index in the bytes pool.

### Constructor Detail

#### MersenneTwister

    public MersenneTwister()

Creates a new random number generator.

The instance is initialized using the current time as the seed.

#### MersenneTwister

    public MersenneTwister(int seed)

Creates a new random number generator using a single int seed.

Parameters:
  `seed` - the initial seed (32 bits integer)

#### MersenneTwister

    public MersenneTwister(int[] seed)

Creates a new random number generator using an int array seed.

Parameters:
  `seed` - the initial seed (32 bits integers array), if null the seed of the generator will be related to the current time

#### MersenneTwister

    public MersenneTwister(long seed)

Creates a new random number generator using a single long seed.

Parameters:
  `seed` - the initial seed (64 bits integer)

### Method Detail

#### setSeed

    public void setSeed(int seed)

Reinitialize the generator as if just built with the given int seed.

The state of the generator is exactly the same as a new generator built with the same seed.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the initial seed (32 bits integer)

#### setSeed

    public void setSeed(int[] seed)

Reinitialize the generator as if just built with the given int array seed.

The state of the generator is exactly the same as a new generator built with the same seed.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the initial seed (32 bits integers array), if null the seed of the generator will be related to the current time

#### setSeed

    public void setSeed(long seed)

Reinitialize the generator as if just built with the given long seed.

The state of the generator is exactly the same as a new generator built with the same seed.

Specified by:
  `setSeed` in interface `RandomGenerator`
Specified by:
  `setSeed` in class `BitsStreamGenerator`
Parameters:
  `seed` - the initial seed (64 bits integer)

#### next

    protected int next(int bits)

Generate next pseudorandom number.

This method is the core generation algorithm. It is used by all the public generation methods for the various primitive types `BitsStreamGenerator.nextBoolean()`, `BitsStreamGenerator.nextBytes(byte[])`, `BitsStreamGenerator.nextDouble()`, `BitsStreamGenerator.nextFloat()`, `BitsStreamGenerator.nextGaussian()`, `BitsStreamGenerator.nextInt()`, `next(int)` and `BitsStreamGenerator.nextLong()`.

Specified by:
  `next` in class `BitsStreamGenerator`
Parameters:
  `bits` - number of random bits to produce
Returns:
  random bits generated